!---------------------------------------------------------------------------------------
! FLEXINVERT : boxarea
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Calculates area of boxes in inversion grid
!---------------------------------------------------------------------------------------

subroutine boxarea()

  use mod_var
 
  implicit none

  integer :: jy,ix,n

  write(logid,fmt='(1X,A40,I5)') 'Number of grid-cells in inversion grid: ',nbox

  allocate(area_box(nbox))
  allocate(dimbox(nbox))
  area_box(:)=0.

  do jy=1,numynest
    do ix=1,numxnest
      area_box(nbox_xy(ix,jy))=area_box(nbox_xy(ix,jy))+area_grid(ixl+ix-1,iyl+jy-1)
    end do
  end do

  do n=1,nbox
    dimbox(n)=n
  end do

end subroutine boxarea

