!---------------------------------------------------------------
! check flexpart runs 
!---------------------------------------------------------------

program check_output

  use mod_dates
  
  implicit none

  character(len=100) :: dirflex,pathname,stnfile,sdump
  character(len=4) :: yyyyst
  character(len=2) :: mmst,ddst
  character(len=7), dimension(100) :: recname
  logical :: lexist
  integer :: ierr,i,dd,mm,mi,mf,yyyy,yyyymm,eomday,numrec
  real, dimension(100) :: reclon,reclat
  integer, dimension(100) :: recalt
  character(len=2), dimension(100) :: rectyp

  dirflex='/xnilu_wrk/rlt/NILU/FLEXOUT/SOGGEA/STATIONS_VERT_RES/'
  stnfile='/xnilu_wrk/rlt/NILU/FLEXDATA/SOGGEA/stations_soggea_2008.def'
  yyyy=2008
  mi=12
  mf=12

  reclon(:)=0.
  reclat(:)=0.
  recalt(:)=0

  open(100,file=trim(stnfile),action='read',status='old',iostat=ierr)
  read(100,*,iostat=ierr,end=10) sdump
  print*, 'Reading station file: '//trim(stnfile)
  i=0
  do while(ierr.eq.0)
    i=i+1
    read(100,fmt='(A7,2X,F5.2,2X,F5.2,1X,I5,1X,A2,1X,A100)',iostat=ierr,end=10) &
         &recname(i),reclat(i),reclon(i),recalt(i),rectyp(i),sdump
    print*, recname(i)
  end do
10 continue
  close(100)
  numrec=i-1
  print*, 'Number of stations: ',numrec

  do i=1,numrec
    do mm=mi,mf
      write(yyyyst,'(I4.4)') yyyy
      write(mmst,'(I2.2)') mm
      yyyymm=yyyy*100+mm
      eomday=calceomday(yyyymm)
      pathname=trim(dirflex)//trim(recname(i))//'/'//yyyyst//mmst
      do dd=1,eomday 
        write(ddst,'(I2.2)') dd
        inquire(file=trim(pathname)//'/grid_time_'//yyyyst//mmst//ddst//'000000_001',exist=lexist)
        if(.not.lexist) then
          print*, 'File not found:',trim(pathname)//'/grid_time_'//yyyyst//mmst//ddst//'000000_001'
        endif
      end do
    end do
  end do

end program check_output 
