!---------------------------------------------------------------------------------------
! FLEXINVERT : gridoperator
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Calculates the interpolation operator for the interpolation from the FLEXPART
!! grid to the inversion grid
!---------------------------------------------------------------------------------------

subroutine gridoperator()

  use mod_var

  implicit none

  integer :: i,j
  integer, dimension(numxgrid*numygrid) :: nbox_vec
  integer, dimension(numxnest*numynest) :: nest_vec

  allocate(gridoper(nbox,numxgrid*numygrid))
  allocate(gridnest(nbox,numxnest*numynest))
  gridoper(:,:)=0
  gridnest(:,:)=0
  nbox_vec(:)=0
  nest_vec(:)=0

  do j=1,numynest
    do i=1,numxnest
      nbox_vec((iyl+j-2)*numxgrid+(ixl+i-1))=nbox_xy(i,j)
      nest_vec((j-1)*numxnest+i)=nbox_xy(i,j)
    end do
  end do

  do i=1,nbox
    where(nbox_vec.eq.i) gridoper(i,:)=1
    where(nest_vec.eq.i) gridnest(i,:)=1
  end do


end subroutine gridoperator

