!---------------------------------------------------------------------------------------
! FLEXINVERT : obscovariance
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Calculate observation error covariance matrix
!! (currently a diagonal matrix)
!---------------------------------------------------------------------------------------

subroutine obscovariance(covr,yerr,nobs)

  use mod_var

  implicit none

  integer :: i,nobs
  real, dimension(nobsteps*numrec) :: yerr
  real, dimension(nobs,nobs) :: covr

  allocate(dimr(nobs))

  covr(:,:)=0.

  do i=1,nobs
    covr(i,i)=yerr(i)**2
    dimr(i)=i
  end do

end subroutine obscovariance

