!---------------------------------------------------------------------------------------
! FLEXINVERT : read2Dncdf
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Reads a 2D netcdf file
!---------------------------------------------------------------------------------------

subroutine read2Dncdf(filename,varname,xdimname,ydimname,nx,ny,var)

  use mod_var

  implicit none

  include 'netcdf.inc'

  character(len=100) :: filename,varname
  character(len=20) :: xdimname,ydimname
  integer :: nid,ierr,xid,yid,varid,nx,ny
  real, dimension(nx,ny) :: var

  ! open netcdf file
  write(logid,*) 'Reading file: '//trim(filename)
  ierr=nf_open(trim(filename),NF_NOWRITE,nid)
  if(ierr.gt.0) then
    write(logid,*) 'Error opening file: '//trim(filename)
  endif

  ! inquire about variables
  ierr=nf_inq_dimid(nid,trim(xdimname),xid)
  if(ierr.gt.0) then
    write(logid,*) 'Error reading dimension: '//trim(xdimname)
  endif
  ierr=nf_inq_dimid(nid,trim(ydimname),yid)
  if(ierr.gt.0) then
    write(logid,*) 'Error reading dimension: '//trim(ydimname)
  endif

  ! read variables
  ierr=nf_inq_varid(nid,trim(varname),varid)
  ierr=nf_get_var_real(nid,varid,var)
  if(ierr.gt.0) then
    write(logid,*) 'Error reading variable: '//trim(varname)
  endif

  ierr=nf_close(nid)

end subroutine read2Dncdf
