!---------------------------------------------------------------------------------------
! FLEXINVERT : readdefinitions
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Reads definition files file.def and control.def  
!---------------------------------------------------------------------------------------

subroutine readdefinitions

  use mod_var
  use mod_dates

  implicit none

  integer :: ierr
  integer :: yyyymm,di,df,eomday

  open(100,file='control.def',action='read',status='old')
  read(100,*)
  read(100,*) datei
  read(100,*)
  read(100,*) datef
  read(100,*)
  read(100,*) lly
  read(100,*)
  read(100,*) ury
  read(100,*)
  read(100,*) llx
  read(100,*)
  read(100,*) urx
  read(100,*)
  read(100,*) tstep
  read(100,*)
  read(100,*) relperiod
  read(100,*)
  read(100,*) trajlen
  read(100,*)
  read(100,*) nzmax
  read(100,*)
  read(100,*) maxpoint
  read(100,*)
  read(100,*) maxspec
  read(100,*)
  read(100,*) spec
  read(100,*)
  read(100,*) molarmass
  read(100,*)
  read(100,*) coef
  read(100,*)
  read(100,*) useemission
  read(100,*)
  read(100,*) uselanduse
  read(100,*)
  read(100,*) maxrec
  read(100,*)
  read(100,*) obstep
  read(100,*)
  read(100,*) obsfilter
  read(100,*)
  read(100,*) bgmethod
  read(100,*)
  read(100,*) method
  read(100,*)
  read(100,*) winback
  read(100,*)
  read(100,*) perturb
  read(100,*)
  read(100,*) seed
  read(100,*)
  read(100,*) measerr
  read(100,*)
  read(100,*) bkgerr
  read(100,*)
  read(100,*) fracerr
  read(100,*)
  read(100,*) uselsm
  read(100,*)
  read(100,*) sigmaland
  read(100,*)
  read(100,*) sigmasea
  read(100,*)
  read(100,*) sigmatime
  read(100,*)
  read(100,*) minerr
  read(100,*)
  read(100,*) maxerr
  read(100,*)
  read(100,*) globerr
  read(100,*)
  read(100,*) optimizbg
  read(100,*)
  read(100,*) scaleflx
  read(100,*)
  read(100,*) checkprior
  read(100,*)
  read(100,*) nlatbin
  read(100,*)
  allocate(latbin(nlatbin))
  read(100,*) latbin
  close(100)

  open(100,file='files.def',action='read',status='old')
  read(100,*)
  read(100,fmt='(A100)') dirinvert
  read(100,*)
  read(100,fmt='(A100)') dirflex
  read(100,*)
  read(100,fmt='(A100)') dirflexinit
  read(100,*)
  read(100,*) usedirflex
  read(100,*)
  read(100,fmt='(A100)') logfile
  read(100,*)
  read(100,fmt='(A100)') dirobs
  read(100,*)
  read(100,*) missval
  read(100,*)
  read(100,fmt='(A100)') stnfile
  read(100,*)
  read(100,fmt='(A100)') fileemis
  read(100,*)
  read(100,fmt='(A100)') emisname
  read(100,*)
  read(100,*) midpoints
  read(100,*)
  read(100,fmt='(A100)') filelanduse
  read(100,*)
  read(100,*) nclass
  read(100,*)
  read(100,fmt='(A100)') filelsm
  read(100,*)
  read(100,fmt='(A100)') lsmname
  read(100,*)
  read(100,fmt='(A100)') fileimmr
  read(100,*)
  read(100,fmt='(A100)') bginame
  read(100,*)
  read(100,fmt='(A100)') dirauxil
  close(100)

  ! check dates
  yyyymm=datef/100
  df=datef-(datef/100)*100
  di=datei-(datei/100)*100
  eomday=calceomday(yyyymm)
  if(di.gt.1.or.df.lt.eomday) then
    print*, 'Error: start/end date not start/end of month'
    stop
  endif

  ! open log file
  logid=500
  open(logid,file=trim(dirinvert)//trim(logfile),status='replace',action='write',iostat=ierr)
  write(logid,*) '***********************************************************'
  write(logid,*) '*                                                         *'
  write(logid,*) '*               FLEXINVERT Version 1.0                    *'
  write(logid,*) '*                                                         *'
  write(logid,*) '***********************************************************'
  write(logid,*) ' '
  write(logid,fmt='(1X,A22,1X,I8,1X,A2,1X,I8)') 'Starting inversion for',datei,'to',datef


end subroutine readdefinitions

