!---------------------------------------------------------------------------------------
! FLEXINVERT : readreclist
!---------------------------------------------------------------------------------------
!  Copyright 2013, Rona Thompson
!
!  FLEXINVERT is free software: you can redistribute it and/or modify
!  it under the terms of the GNU General Public License as published by
!  the Free Software Foundation, either version 3 of the License, or
!  (at your option) any later version.
!
!  FLEXINVERT is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License
!  along with FLEXINVERT.  If not, see <http://www.gnu.org/licenses/>.
!---------------------------------------------------------------------------------------
!> Read from stnfile a list of receptors to include in inversion 
!---------------------------------------------------------------------------------------

subroutine readreclist()

  use mod_var

  implicit none

  integer :: i,ierr
  character(len=100) :: sdump

  allocate(reclon(maxrec))
  allocate(reclat(maxrec))
  allocate(recalt(maxrec))
  allocate(recname(maxrec))
  allocate(rectyp(maxrec))

  reclon(:)=0.
  reclat(:)=0.
  recalt(:)=0

  open(100,file=trim(stnfile),action='read',status='old',iostat=ierr)
  if(ierr.gt.0) write(logid,*) 'Error opening file: '//trim(stnfile)
  read(100,*,iostat=ierr,end=10) sdump
  write(logid,*) 'Reading station file: '//trim(stnfile)
  write(logid,*) 'Stations: '
  i=0
  do while(ierr.eq.0)
    i=i+1
    read(100,fmt='(A7,2X,F5.2,2X,F5.2,1X,I5,1X,A2,1X,A100)',iostat=ierr,end=10) &
         &recname(i),reclat(i),reclon(i),recalt(i),rectyp(i),sdump
    write(logid,*) recname(i)
  end do
10 continue
  close(100)
  numrec=i-1
  write(logid,fmt='(1X,A20,I5)') 'Number of stations: ',numrec

end subroutine readreclist

